﻿package aibase
{
	internal class DynamicCohesion implements GroupStrategy
	{
		public static const INSTANCE:GroupStrategy = new DynamicCohesion(DynamicSeek.INSTANCE);
		public function getName():String { return "D_Cohesion"; } 
		private var neighbors:Array = null;
		private var moveDelegate:Strategy;
		
		public function DynamicCohesion(_moveDelegate:Strategy)
		{
		moveDelegate = 	_moveDelegate;
		}
		
		public function setNeighbors(_others:Array):void
		{
			neighbors = _others;
		}
		
		
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			var location:Vec2f = new Vec2f(0,0);
			for(var x:int=0;x<neighbors.length;x++)
			{
				location = Utils.add(location,neighbors[x].kinematic.position);
				
			}
			location = Utils.mult(location, (1.0/neighbors.length));
			
			var fake:Bot = new Bot();	
			fake.kinematic.position = location;
			return moveDelegate.getSteering(a,fake);
		}
		
	}
	
}