﻿package aibase
{
	internal class FlockingAlignment implements GroupStrategy
	{
		public static  const INSTANCE:GroupStrategy = new FlockingAlignment();
		public function getName():String
		{
			return "D_Flock_align";
		}
		private var neighbors:Array = null;

		public function setNeighbors(_others:Array):void
		{
			neighbors = _others;
		}
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			var location:Vec2f = new Vec2f(0,0);
			for (var x:int=0; x<neighbors.length; x++)
			{
				location = Utils.add(location,neighbors[x].kinematic.velocity);
				location = Utils.mult(location, (1.0/neighbors.length));
			}
			return new SteeringOutput(location,0,Utils.l2(location));
		}
	}
}