﻿package aibase
{
	
	internal class SteeringCombinator implements Strategy
	{
		internal var steerings:Array;
		internal var weights:Array;
		private var strat_name:String;
		public function SteeringCombinator(_steerings,_weights,_stratname:String)
		{
			this.steerings = _steerings;
			this.weights = _weights;
			this.strat_name = _stratname;
		}
		public function getName():String
		{
			return strat_name;
		}
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			//return steerings[0].getSteering(a,b);
			
			var lin:Vec2f = new Vec2f(0,0);
		//var x = 1;
		for (var x=0; x<steerings.length; x++)
			{
				var	strat = steerings[x];	
				var weight = weights[x];
				
				var steer:SteeringOutput = SteeringOutput(steerings[x].getSteering(a,b));
				lin = Utils.add(lin,Utils.mult(steer.linear,weights[x]));//steer.strength));
			}
			var strength:Number = Utils.l2(lin);
			//lin = Utils.scaleToLength(lin,1);
			var fake:Bot = new Bot();
			fake.kinematic.orientation = Utils.orientationFromDirection(lin);
			return new SteeringOutput(lin,
					AlignStrategy.INSTANCE.getFace(a,fake,new Vec2f(0,0)),
					strength);
		}
	}
}