﻿package aibase
{
	internal class CenterAttraction implements Strategy
	{
		public static const INSTANCE:Strategy = new CenterAttraction();
		public function getName():String { return "Seek"; }
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			var direction = Utils.difference(a.kinematic.position, new Vec2f(Utils.WIDTH*.5,Utils.HEIGHT*.5));
			return buildSteering(direction,a.kinematic.maxAcceleration,
								 a.faceStrategy.getFace(a,b,b.kinematic.position));
		}
		internal function buildSteering(direction:Vec2f, maxAccel:Number, angular:Number):SteeringOutput
		{
			var strength:Number = Utils.l2(direction);
			direction = Utils.scaleToLength(direction,maxAccel);
			return new SteeringOutput(direction, angular,strength);
		}
	}
}