﻿package aibase
{
	internal class DynamicFace implements FaceStrategy
	{
		internal static const INSTANCE = new DynamicFace();
		
		public function getName():String { return "D_FACE"; }
		public function getFace(a:Bot, b:Bot, target:Vec2f):Number
		{
			var direction:Vec2f = Utils.difference(a.kinematic.position, target);
			//trace("Direction = "+direction.toString());
			if(Utils.l2(direction) < .00001)
			{
				return 0;
			}
			var fake:Bot = new Bot();
			fake.kinematic.position.x = target.x;
			fake.kinematic.position.y = target.y;			
			//trace(direction.toString());
			//duck
			// direction = new Vec2f(-10,15);
			fake.kinematic.orientation = Utils.orientationFromDirection(direction);
			//trace("orientation: "+fake.kinematic.orientation);
			return AlignStrategy.INSTANCE.getFace(a,fake,Vec2f.zero());
		}
	}
}