﻿package aibase
{
	internal class LimitedDynamicFlee implements Strategy
	{
		public static  const INSTANCE:Strategy = new LimitedDynamicFlee();
		public function getName():String
		{
			return "D_LIMITED_FLEE";
		}
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			if (Utils.l2(Utils.difference(a.kinematic.position,b.kinematic.position)) > Globals.SHEEP_FEAR_DISTANCE())
			{
				return new SteeringOutput(new Vec2f(0,0),0,0);
			}
			var seek:SteeringOutput = DynamicSeek.INSTANCE.getSteering(a,b);
			return new SteeringOutput(Utils.mult(seek.linear,-1),a.faceStrategy.getFace(a,b,Vec2f.zero()),seek.strength);
		}
	}
}