﻿/**
   ActionScript 3.0 Class for a basic path
   Written by Brian J. Stinar
   11/9/2008 
   For A.I. For Video Games Final Project with
   Jon Bradley
   
   This class is based on the "path" class implemented
   by Bill Klein for A.I. for Video Games, in Processing.
**/
package aibase{

	//import Vec2f; // Jon's Vector library for 2D vector computation
	
	class Path{
	
		public function getParam(position : Vec2f, lastParam : Number) : Number{
			return 0;
		} // end getParam()

		public function findNearestPointOnLine(pt : Vec2f, start : Vec2f, end : Vec2f) : Vec2f{
			var linelength : Number = Utils.Vec2fLength(Utils.difference(start, end));
			var u : Number = (((pt.x - start.x) * (end.x - start.x)) + ((pt.y - start.y) * (end.y - start.y))) / (linelength * linelength);
			
			var intpt : Vec2f; 
			
			if (u < 0) {
				intpt = start;
			}
			
			else if (u > 1.0){
				intpt = end;
			}
			
			else {
			 	intpt = Utils.add(Utils.mult((Utils.sub(end, start)), u), start);
				//intpt = start.plus(end.minus(start).times(u));
				// ((end - start) * u) + start
			}
			
			return intpt;
		} // end findNearestPointOnLine()
							
				
		public function Path(){
			
		}
							
	} // end class Path
} // end package aibase